/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package koverja_test;

import AlgoTools.IO;
import java.util.HashMap;
import java.util.Random;
import sortieren.BubbleSort;
import sortieren.HeapSort;
import sortieren.MergeSort;
import sortieren.QuickSort;
import sortieren.SelectionSort;

/**
 *
 * @author user
 */
public class Main {

    /**
     * @param args the command line arguments
     */
    public HashMap<String,Boolean> sort;
    public HashMap<String,Long> results;
    public int[] folge;
    public Random rand = new Random();

    public static void main(String[] args) {
      System.out.println("(1) mit GUI starten");
      System.out.println("(2) ohne GUI starten");
      System.out.println("(0) beenden");
      int i = IO.readInt("#: ");
      switch(i){
        case 1: new mainFrame();
          break;
        case 2: new Main().dialog();
      }
    }

    public void dialog(){
      createSortMap();
      initializeResults();
      randomizeSequence(10000);
      int i = -1;
      while(i != 0){
        showSortMap();
        System.out.println("Laenge der Folge: "+folge.length);
        i = showMainMenu();
      }
    }

    public void showSortMap(){
      char c = 'X';
      int i = 0;
      for(String s: sort.keySet()){
        if(sort.get(s).booleanValue()) c = 'X';
        else c = '-';
        System.out.println("("+i+++") "+"["+c+"] "+s);
      }
    }

    public int showMainMenu(){
      System.out.println("(1) Algortihmus aktivieren/deaktivieren");
      System.out.println("(2) Groesse der Folge aendern");
      System.out.println("(3) Test starten");
      System.out.println("(0) beenden");
      int i = IO.readInt("#: ");
      while(i < 0 || i > 3){
        i = IO.readInt("#: ");
      }
      switch(i){
        case 1: showActivationMenu();
          break;
        case 2: showSequenceMenu();
          break;
        case 3: runTest(); showResults();
      }
      return i;
    }

    public void showActivationMenu(){
      System.out.println("Welcher Algorithmus soll aktiviert/deaktiviert werden?");
      showSortMap();
      int i = IO.readInt("#: ");
      while(i < 0 || i > 4){
        i = IO.readInt("#: ");
      }
      String name = noToName(i);
      Boolean bool = sort.get(name);
      sort.remove(name);
      bool = !bool;
      sort.put(name, bool);
    }

    public void showSequenceMenu(){
      System.out.println("Wie lang soll die Folge sein?");
      int i = IO.readInt("#: ");
      while(i < 3 || i > 200000){
        System.out.println("Ungueltige Eingabe!");
        i = IO.readInt("#: ");
      }
      randomizeSequence(i);
    }

    public void showResults(){
      System.out.println("Ergebnisse:");
      for(String s: results.keySet()){
        if(sort.get(s).booleanValue()){
          System.out.println(s+" : "+results.get(s)+" ms");
        }
      }
    }

    public void createSortMap(){
      sort = new HashMap<String, Boolean>();
      sort.put("BubbleSort", Boolean.TRUE);
      sort.put("SelectionSort", Boolean.TRUE);
      sort.put("MergeSort", Boolean.TRUE);
      sort.put("QuickSort", Boolean.TRUE);
      sort.put("HeapSort", Boolean.TRUE);
    }

    public String noToName(int i){
      switch(i){
        case 0: return "QuickSort";
        case 1: return "MergeSort";
        case 2: return "HeapSort";
        case 3: return "SelectionSort";
        case 4: return "BubbleSort";
        default: return null;
      }
    }

    public void initializeResults(){
      results = new HashMap<String, Long>();
      for(int i = 0; i < 5; i++){
        results.put(noToName(i), 0L);
      }
    }

    public void randomizeSequence(int size){
      if(! (size < 3)){
        folge = new int[size];
        for(int i = 0; i < size; i++)
          folge[i] = rand.nextInt();
      }
    }

    public void runTest(){
      System.out.println("Running test...");
      for(String s: sort.keySet()){
        if(sort.get(s).booleanValue()){
          System.out.print(s+"...");
          runAlgorithm(s);
          System.out.println(" DONE");
        }
      }
    }

    public void runAlgorithm(String name){
      long start,ende;
      if(name == "BubbleSort"){
        start = System.currentTimeMillis();
        BubbleSort.sort(folge.clone());
        ende = System.currentTimeMillis();
        ende-=start;
        results.remove(name);
        results.put(name, ende);
      }
      if(name == "SelectionSort"){
        start = System.currentTimeMillis();
        SelectionSort.sort(folge.clone());
        ende = System.currentTimeMillis();
        ende-=start;
        results.remove(name);
        results.put(name, ende);
      }
      if(name == "MergeSort"){
        start = System.currentTimeMillis();
        MergeSort.sort(folge.clone());
        ende = System.currentTimeMillis();
        ende-=start;
        results.remove(name);
        results.put(name, ende);
      }
      if(name == "QuickSort"){
        start = System.currentTimeMillis();
        QuickSort.sort(folge.clone());
        ende = System.currentTimeMillis();
        ende-=start;
        results.remove(name);
        results.put(name, ende);
      }
      if(name == "HeapSort"){
        start = System.currentTimeMillis();
        HeapSort.sort(folge.clone());
        ende = System.currentTimeMillis();
        ende-=start;
        results.remove(name);
        results.put(name, ende);
      }
    }
}
